#!/bin/bash

# see also: https://kvz.io/bash-best-practices.html
set -o pipefail
set -o nounset

########################################### Preparing local files for the build ###########################################

## Suppressing git warnings due to script's self-destruction
git update-index --assume-unchanged "$0"

## Getting rid of carriage return (\r) in the wp-config.php build script
## that causes errors in the Linux-based WordPress (wp) container
if [[ "$OSTYPE" == "msys" || "$OSTYPE" == "cygwin" || "$OSTYPE" == "win32" ]]; then
	sed -i 's/\r$//' wp/scripts/setup.sh
	
	## Suppressing git warnings due to change in script
	git update-index --assume-unchanged wp/scripts/setup.sh
fi

########################################### Building Container Images and Deploying ###########################################

# Running Build and deploy scripts
./bin/install.sh        # Build Script
docker-compose down
./bin/start.sh          # Deploy Script

########################################### Configuring and Setting up site ###########################################

# Setting up color variables for STDOUT fonts
# Using tput
# red=`tput setaf 1`
# green=`tput setaf 2`
# reset=`tput sgr0`

# Using ANSI escape code
red='\e[0;31m'
green='\e[1;32m'
# Other green shades attempted:
# green='\e[0;32m'
# green='\u001b[32m'
highlight='\e[42m'
# Other green code for green background attempted:
# highlight='\033[0;42m'
reset='\e[0m'    # Text Reset


# Activate ACF plugin

echo "Checking the WordPress container ..."

while true
do
    # Checking whether wp-config.php has been generated by the script
    # This is needed by the WordPress container (wp) for successful
    # connection to the MySQL database container (db)
    docker-compose exec wp wp config path &>/dev/null
    if [ $? -eq 0 ]; then
        echo -e "${green}Success:${reset} wp-config.php has been generated"
        docker-compose exec wp wp plugin activate advanced-custom-fields-pro
        break
    fi
    echo "Waiting for config file (wp-config.php) to be setup..."
    sleep 2
done

set -o errexit

# Getting the URL on which the project will be hosted. This variable would be used latter in
# this script to generate a cache. This script is intended to run also on PLAY WITH DOCKER (PWD).
# PWD needs to set the url for the site to work properly when deployed on the platform.
# url=$(docker-compose exec db mysql -h db -u neighbor -pneighbor -e "select option_value from neighbor.wp_options where option_name='siteurl'")
url="http://localhost:8000"

# Checking whether the script is running on PWD.
# This is done by getting Fully Qualified Domain Name (FQDN) from PWD
if [ ! -z "$PWD_HOST_FQDN" ]; then
	ip=$(ifconfig eth1 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}' )
	hyphen_ip=$(echo $ip | sed 's/\./-/g' )
	url=$(echo "ip$hyphen_ip-$SESSION_ID-8000.direct.labs.play-with-docker.com")
	url="http://${url}"

    # Fixing the url in the database on Play-With-Docker (PWD)
	docker-compose exec db mysql -h db -u neighbor -pneighbor -e "UPDATE neighbor.wp_options SET option_value = replace (option_value , 'http://localhost:8000' , \
		'${url}/')         \
	WHERE option_name = 'home' OR option_name = 'siteurl'"
fi

# Generating cache from Twenty Nineteen theme and switching back to primary theme
## Switch to Twenty Nineteen theme
echo "Setting up the WordPress theme: Activating Parent theme"
docker-compose exec wp wp theme activate twentynineteen

echo "Setting up the WordPress theme: Generating cache from parent theme ..."
curl "$url"  > /dev/null    # Generating cache

## Switch back to neighbor.group theme
echo "Setting up the WordPress theme: Switching back to primary theme ..."
docker-compose exec wp wp theme activate neighbor.group

# Checking themes
echo "Listing available themes: The table below should indicate the theme structure and label the parent theme"
docker-compose exec wp wp theme list

# Setting up the map with Mapbox
echo "What is your Mapbox API key?"
read -p "> " MAPBOX_KEY

if [ $MAPBOX_KEY ]; then
    echo -e "\nSetting up Mapbox: Adding Mapbox API key to the Database ...\n"


    docker-compose exec db mysql -h db -u neighbor -pneighbor -e "\
    INSERT INTO neighbor.wp_options (option_name, option_value, autoload) \
    VALUES ('options_mapbox_api_key','$MAPBOX_KEY', 'no')" > /dev/null

    mapdbins1=$?    # Recording success or failure of operation

    docker-compose exec db mysql -h db -u neighbor -pneighbor -e "\
    INSERT INTO neighbor.wp_options (option_name, option_value, autoload) \
    VALUES ('options_map_default_lat','42.6951', 'no')" > /dev/null

    mapdbins2=$?    # Recording success or failure of operation

    docker-compose exec db mysql -h db -u neighbor -pneighbor -e "\
    INSERT INTO neighbor.wp_options (option_name, option_value, autoload) \
    VALUES ('options_map_default_lng','-73.7025', 'no')" > /dev/null

    mapdbins3=$?    # Recording success or failure of operation

    docker-compose exec db mysql -h db -u neighbor -pneighbor -e "\
    INSERT INTO neighbor.wp_options (option_name, option_value, autoload) \
    VALUES ('options_map_default_zoom','12', 'no')" > /dev/null

    if [[ $mapdbins1 -eq 0 && $mapdbins2 -eq 0 && $mapdbins3 -eq 0 && $? -eq 0 ]]; then
        echo -e "\n${green}Success:${reset} Mapbox API key has been added to the Database\n\n"
    fi

fi

# Adding Geospatial layer to map
echo "Creating table 'wp_geospatial'"
docker-compose exec db mysql -h db -u neighbor -pneighbor -e "CREATE TABLE IF NOT EXISTS neighbor.wp_geospatial ( \
    geoid VARCHAR(255), \
    name VARCHAR(255), \
    lng_min FLOAT, \
    lat_min FLOAT, \
    lng_max FLOAT, \
    lat_max FLOAT, \
    boundary TEXT, \
    boundary_geom GEOMETRY \
)"
if [ $? -eq 0 ]; then
    echo -e "${green}Success:${reset}\tTable created\n"
    echo "Downloading geospatial data ..."
    wget https://code.phiffer.org/neighbor.group/geospatial/raw/main/data/tl_2019_36_bg.zip
    if [ $? -eq 0 ]; then
        echo -e "${green}Success:${reset}\tDownload complete\n"
        echo "Extracting geospatial data into uploads folder ..."
        unzip tl_2019_36_bg.zip -d wp/wp-content/uploads/
        echo "Cleaning directory of unneeded files ..."
        rm tl_2019_36_bg.zip
        echo "Populating database with geospatial data ..."
        docker-compose exec wp wp geospatial ../../uploads/tl_2019_36_bg &&
            echo -e "${green}Success:${reset}\tGeospatial data added to database"
    else
        echo -e "${red}Failure:${reset}\tGeospatial data not available"
    fi
else
    echo -e "${red}Failure:${reset}\tA problem occured while creating table"
fi

########################################### Winding down script ###########################################
echo "-------------------------------"
echo "Setup completed successfully."
echo "-------------------------------"
echo
echo "From now on, you can run the shell commands"
echo "'docker-compose down'     - to stop the containers and"
echo "'docker-compose up [-d]'  - to start up the containers"
echo

echo -e "${green}Success:${reset}\tYou can now view the site at ${url}/"
echo -e "\t\tAlso check out the map at ${url}/map"

if [ ! $MAPBOX_KEY ]; then
    echo -e "\t\t${red}This script has not setup Mapbox, so the map at \e[7m${url}/map\e[27m will be blank."
    echo -e "\t\tYou can add the Mapbox API key and defaults for the Latitude and Longitude in the Options"
    echo -e "\t\tsection of WordPress Admin."
    echo -e "\t\tLogin to WordPress admin at:"
    echo -e "\t\t\t\e[7m${url}/wp-login.php\e[27m"
    echo -e "\t\tand add your Mapbox configuration settings at:"
    echo -e "\t\t\t\e[7m${url}/wp-admin/admin.php?page=acf-options${reset}"
fi

echo -en "\n\n\t\t\t${highlight}ENJOY"'!!!'"${reset}"

echo -e "\n\n\n${red}This script will self-destruct in a few nanoseconds ...${reset}\n"
rm -- "$0"
